<template>
  <div class="app-container">
    <el-col :span="6">
      <el-card>
        <!-- 捐献案例列表 -->
        <el-table @row-click="nihao" border :data="jibing">
          <el-table-column label="姓名" align="center" prop="name" />
        </el-table>
        <!-- hide-on-single-page -->
        <pagination
          v-show="total > 0"
          style="margin-left: 100px"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getfundlist"
        />
      </el-card>
    </el-col>
    <!-- </el-form> -->
    <el-col :span="18">
      <el-card>
        <el-table :data="distributedetaillist" border v-loading="loading">
          <el-table-column align="center" label="伦理委员会劳务发放总表">
            <el-table-column
              label="受益人"
              align="center"
              prop="beneficiaryname"
            />
            <el-table-column label="职称" align="center" prop="title" />
            <el-table-column label="证件号码" align="center" prop="idcardno" />
            <el-table-column label="税前金额" align="center" prop="amount" />
            <el-table-column
              label="开户银行"
              align="center"
              prop="depositbank"
            />
            <el-table-column
              label="开户账号"
              align="center"
              prop="bankcardno"
            />
            <el-table-column label="服务内容" align="center" prop="itemname" />
            <el-table-column label="参会次数" align="center" prop="quantity" />
            <el-table-column
              label="费用总额"
              align="center"
              prop="totalamount"
            />
          </el-table-column>
          <el-table-column label="案例总数" align="center" prop="casecount" />
          <el-table-column
            label="案例描述"
            align="center"
            prop="casedescribe"
          />
        </el-table>
      </el-card>
    </el-col>
  </div>
</template>

<script>
import {
  listDistributesummary,
  getDistributesummary,
  delDistributesummary,
  addDistributesummary,
  updateDistributesummary,
  exportDistributesummary,
  getSummaryByInfoIdlist,
} from "@/api/project/distributesummary";
import { getownFundDetail } from "@/api/project/funddetail";
import { listFund } from "@/api/project/fund";
import {
  listDonatebaseinfo,
  getDonatebaseinfo,
} from "@/api/project/donatebaseinfo";
import elementIcons from "../../components/icons/element-icons";
export default {
  name: "Distributesummary",
  dicts: [
    "sys_OrganizationType",
    "sys_DonationStatus",
    "sys_depositbank",
    "sys_FamilyRelation",
    "sys_IDType",
    "sys_ConsolationType",
    "sys_fund_type",
    "sys_finsubject",
  ],
  data() {
    return {
      jibing: [
        { name: "aaa", id: "1" },
        // {name:'bbb',id:'2'},
        // {name:'ccc',id:'3'},
      ],
      donatebaseinfoList: [],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专家费用分发汇总主表格数据
      distributesummaryList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dise: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        donorno: null,
        donorname: null,
        userno: null,
        username: null,
        unitname: null,
        unitno: null,
        departmentno: null,
        departmentname: null,
        recordstatus: null,
        uploadflag: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      curCase: {},
      distributedetaillist: [],
      labels: [],
      ceshi: [],
    };
  },
  created() {
    this.getList();
    this.getBaseInfoList();
    this.getfundlist();
    //  this.selectDonotor();
  },
  methods: {
    getfundlist() {
      let list = [];
      listFund().then((res) => {
        console.log("fund数据", res);

        list = res.rows;
        for (let i = 0; i < list.length; i++) {
          this.jibing.push({
            name: list[i].donorname,
            id: list[i].id,
          });

          // this.jibing[i].name = list[i].donorname;
          // this.jibing[i].id = list[i].id
        }
        console.log("jibing", this.jibing);
        // jibing
      });
    },
    nihao(row) {
        console.log('checkone:',row);
        getownFundDetail(row.id).then(res=>{
          const data = res.data;
          console.log('劳务汇总',res)
          for(let i=0;i<data.length;i++){
            data[i].totalamount = data[i].amount;
          }
          this.distributedetaillist = this.uniqueArrObj(data, 'itemtype', 'totalamount')
        })
    },
    uniqueArrObj(arr, addKey) {
      if (!Array.isArray(arr)) return;
      const tempArr = [];
      const tempObj = {};
      arr.forEach((ele, i) => {
        if (!tempObj[arr[i].idcardno]) {
          tempArr.push(arr[i]);
          tempObj[arr[i].idcardno] = true;
          arr[i].quantity = 1;
          arr[i].casedescribe = arr[i].donorname;
        } else {
          tempArr.forEach((ele) => {
            if (ele.idcardno === arr[i].idcardno) {
              ele.quantity += 1;

              ele.casedescribe = arr[i].donorname + ele.donorname;

              ele.totalamount += arr[i].totalamount;
            }
          });
        }
      });
      return tempArr;
    },

    selectDonotor(row, column, event) {
      console.log("row点击传递的数据", row);
      this.curCase = row;
      console.log("qweqwe", this.curCase);
      this.getfundList();
    },
    getfundList() {
      let infoid = this.curCase.id;
      this.loading = true;
      getSummaryByInfoIdlist(infoid).then((res) => {
        console.log("niuniuniu", res);
        this.loading = false;
        this.distributesummaryList = res.data;
      });
    },
    /** 查询专家费用分发汇总主列表 */
    getList() {
      this.loading = true;
      listDistributesummary(this.queryParams).then((response) => {
        console.log("列表，", response);
        this.distributesummaryList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        infoid: null,
        donorno: null,
        donorname: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        userno: null,
        username: null,
        unitname: null,
        unitno: null,
        unituserno: null,
        casecount: null,
        casedescribe: null,
        totalamount: null,
        applytype: null,
        managerno: null,
        managername: null,
        departmentno: null,
        departmentname: null,
        operator: null,
        checher: null,
        financedirector: null,
        opodirector: null,
        remark: null,
        recordstatus: "0",
        uploadflag: null,
        uploadtime: null,
      };
      this.resetForm("form");
    },
    getBaseInfoList() {
      this.loading = true;
      listDonatebaseinfo(this.queryParams).then((response) => {
        console.log("dawd", response);
        this.donatebaseinfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专家费用分发汇总主";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getDistributesummary(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专家费用分发汇总主";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateDistributesummary(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDistributesummary(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除专家费用分发汇总主编号为"' + ids + '"的数据项？')
        .then(function () {
          return delDistributesummary(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal
        .confirm("是否确认导出所有专家费用分发汇总主数据项？")
        .then(() => {
          this.exportLoading = true;
          return exportDistributesummary(queryParams);
        })
        .then((response) => {
          this.$download.name(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
